"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DynamicJsonfield = void 0;
const react_1 = require("react");
const react_2 = require("@fluentui/react");
const react_3 = __importDefault(require("react"));
const Json_1 = require("../../../../utils/common/Json");
const DynamicJsonfield = (props) => {
    var _a;
    const [value, setValue] = (0, react_1.useState)(props.value);
    (0, react_1.useEffect)(() => setValue(props.value), [props.value]);
    const onChange = (ev, value) => {
        let jsonObj = Json_1.json.tryParse(value);
        let jsonStringValue = jsonObj ? Json_1.json.tryStringify(jsonObj) : undefined;
        setValue(jsonStringValue);
        props.onChange(jsonStringValue);
    };
    return react_3.default.createElement(react_2.TextField, { defaultValue: value, onChange: onChange, disabled: props.disabled, multiline: true, resizable: (_a = props.config) === null || _a === void 0 ? void 0 : _a.resizable, onBlur: () => props.onBlur(props.value), errorMessage: props.errorMessage ? `${props.errorMessage} and string must be of correct JSON format` : undefined });
};
exports.DynamicJsonfield = DynamicJsonfield;
//# sourceMappingURL=DynamicJsonfield.js.map