"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DynamicPredefinedArrayField = void 0;
const react_1 = require("react");
const react_2 = require("@fluentui/react");
const Language_1 = require("../../../../models/language/Language");
const react_3 = __importDefault(require("react"));
const DynamicPredefinedArrayField = (props) => {
    var _a;
    const [value, setValue] = (0, react_1.useState)(props.value);
    (0, react_1.useEffect)(() => setValue(props.value), [props.value]);
    const [options, setOptions] = (0, react_1.useState)();
    (0, react_1.useEffect)(() => {
        var _a, _b, _c, _d;
        // async fetch of values
        let asyncGetter = (_b = (_a = props.config) === null || _a === void 0 ? void 0 : _a.predefinedOptions) === null || _b === void 0 ? void 0 : _b.optionsAsync;
        if (asyncGetter != null) {
            setOptions([{ key: -1, text: Language_1.lang.texts.areas.common.loading }]);
            let fetch = () => __awaiter(void 0, void 0, void 0, function* () {
                try {
                    const options = yield asyncGetter();
                    setOptions(options);
                }
                catch (error) {
                    setOptions([{ key: -1, text: Language_1.lang.texts.areas.form.dropdownFailedFetch }]);
                    console.error(error);
                }
            });
            fetch();
        }
        // use static values
        else
            setOptions((_d = (_c = props.config) === null || _c === void 0 ? void 0 : _c.predefinedOptions) === null || _d === void 0 ? void 0 : _d.options);
    }, [(_a = props.config) === null || _a === void 0 ? void 0 : _a.predefinedOptions]);
    return react_3.default.createElement(react_2.Dropdown, { disabled: props.disabled, 
        // multiSelect={props.config?.multiSelect ?? false}
        options: options !== null && options !== void 0 ? options : [], selectedKey: value, 
        // selectedKeys={ props.config?.multiSelect ? props.Value as Array<any> || [] : undefined }
        onChange: (event, option, index) => props.onChange(option === null || option === void 0 ? void 0 : option.key), errorMessage: props.errorMessage });
};
exports.DynamicPredefinedArrayField = DynamicPredefinedArrayField;
//# sourceMappingURL=DynamicPredefinedArrayField.js.map