"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FluentFormShimmer = void 0;
const react_1 = require("react");
const react_2 = require("@fluentui/react");
const useIsMounted_1 = __importDefault(require("../../../../../hooks/useIsMounted"));
const Language_1 = require("../../../../../models/language/Language");
const react_3 = __importDefault(require("react"));
const wrapperClass = (0, react_2.mergeStyles)({
    padding: 2,
    selectors: {
        '& > .ms-Shimmer-container': {
            margin: '5px 0',
        },
    },
});
const shimmerLabel = [
    { type: react_2.ShimmerElementType.line, height: 20 },
];
const shimmerInput = [
    { type: react_2.ShimmerElementType.line, height: 30 },
];
const propertyShimmer = (react_3.default.createElement("div", { className: wrapperClass },
    react_3.default.createElement(react_2.Shimmer, { shimmerElements: shimmerLabel, width: "35%" }),
    react_3.default.createElement(react_2.Shimmer, { shimmerElements: shimmerInput })));
const FluentFormShimmer = props => {
    var _a;
    const [timedOut, setTimedOut] = (0, react_1.useState)(false);
    const isMounted = (0, useIsMounted_1.default)();
    (0, react_1.useEffect)(() => {
        var _a;
        setTimeout(() => {
            if (!isMounted())
                return;
            setTimedOut(true);
        }, (_a = props.timeout) !== null && _a !== void 0 ? _a : 2000);
    }, []);
    return (timedOut
        ? react_3.default.createElement(react_2.MessageBar, { key: "formbuilder-shimmer-bar", messageBarType: react_2.MessageBarType.error, styles: { root: { width: "100%" } } }, (_a = props.timeoutMessage) !== null && _a !== void 0 ? _a : Language_1.lang.texts.areas.common.schemaNotFound)
        : react_3.default.createElement("div", { style: { paddingBottom: "10px" }, key: "formbuilder-shimmer" }, [1, 2, 3, 4, 5].map(_ => propertyShimmer)));
};
exports.FluentFormShimmer = FluentFormShimmer;
//# sourceMappingURL=FluentFormShimmer.js.map