"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DelayedSearchBox = void 0;
const react_1 = require("react");
const react_2 = require("@fluentui/react");
const Language_1 = require("../../../../../../models/language/Language");
const react_3 = __importDefault(require("react"));
const Debounce_1 = require("../../../../../../utils/common/Debounce");
const DelayedSearchBox = props => {
    var _a;
    let _searchTimer = (0, react_1.useRef)();
    const OnChange = (value) => {
        var newTimer = (0, Debounce_1.debounce)(_searchTimer.current, () => props.onChange(value), props.delay);
        _searchTimer.current = newTimer;
    };
    return react_3.default.createElement(react_2.SearchBox, { className: props.className, placeholder: (_a = props.searchPlaceHolder) !== null && _a !== void 0 ? _a : Language_1.lang.texts.areas.list.searchDefaultPlaceholder, onChange: (e, newValue) => OnChange(newValue), disabled: props.disabled, styles: { root: { maxWidth: "450px" } }, autoFocus: true, autoComplete: 'off', onFocus: props.onFocus });
};
exports.DelayedSearchBox = DelayedSearchBox;
//# sourceMappingURL=DelayedSearchBox.js.map