import React from 'react';
import { IFormSchema } from '../models/schema/IFormSchema';
import { ValidationOverride } from '../models/validation/ValidationOverride';
import { IFormItem } from '../modules/IFormItem';
import { IFormBuilderListProps } from './FormBuilder';
import { IFormGrouping } from '../interfaces/IFormGrouping';
export interface IFormListRenderProps<T extends IFormItem> extends IFormListProps<T> {
    onItemChange?: (item: T) => void;
}
export interface IFormListProps<T extends IFormItem> {
    itemType: new () => T;
    items: Array<T>;
    schema: IFormSchema<T>;
    groupContainer?: React.ElementType<{
        groupings: Array<IFormGrouping>;
    }>;
    groupRender?: (grouping: IFormGrouping, children: Array<any>) => JSX.Element;
    validationOverride?: ValidationOverride;
    listProps: IFormBuilderListProps<T>;
    keyPrefix?: string;
}
export declare type FormListRef<T extends IFormItem> = {
    getItem: () => Array<T>;
};
export declare const FormList: React.ForwardRefExoticComponent<IFormListProps<IFormItem> & React.RefAttributes<unknown>>;
