import { SetStateAction, Dispatch } from "react";
declare type ReadOnlyRefObject<T> = {
    readonly current: T;
};
/**
 * Hook for adding a ref to the regular usestate hook.
 * The ref is automatically updated when setstate is called.
 * @returns a regular usestate where a ref is included
 */
export declare const useStateRef: <S>(initialState?: S | (() => S) | undefined) => [S, Dispatch<SetStateAction<S>>, ReadOnlyRefObject<S>];
export {};
