import { SchemaProvider } from "../models/schema/ISchemaProvider";
interface IObjectKeys {
    [key: string]: string | keyof IFormItem | any | undefined;
}
export interface IFormItem extends IObjectKeys {
}
export declare type SchemaProviderWrapper = typeof SchemaProvider;
export declare type FormItemWrapper = IFormItem;
export declare type SchemaProviderWrapperCreate = new () => SchemaProviderWrapper;
export interface ProviderMapping {
    key: string;
    itemType: () => IFormItem;
    provider: SchemaProviderWrapper;
}
export declare module IFormItem {
    const register: <T extends typeof SchemaProvider>(provider: T) => (ctor: Function) => void;
    const getImplementations: () => Array<ProviderMapping>;
    const getSchemaProvider: <T extends IFormItem>(type: T) => ProviderMapping | undefined;
}
export {};
