"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IFormItem = void 0;
const Factory_1 = require("../utils/Factory");
// add a registry of the type you expect
var IFormItem;
(function (IFormItem) {
    const implementations = [];
    IFormItem.register = (provider) => {
        let instance = new Factory_1.Factory().create(provider);
        let key = instance.key;
        let itemType = instance.itemType;
        implementations.push({ key, itemType, provider });
        return (ctor) => console.log("IFormItem class registered: " + key);
    };
    IFormItem.getImplementations = () => {
        return implementations;
    };
    IFormItem.getSchemaProvider = (type) => {
        return implementations.find(_ => _.itemType() === type);
    };
})(IFormItem = exports.IFormItem || (exports.IFormItem = {}));
//-----------------------------------------------------------------------------------------------
// export namespace IFormItem {
//     const implementations: Map<string, SchemaProviderWrapper> = new Map();
//     export const register = <V extends FormItemWrapper, T extends SchemaProviderWrapper>(schemaProvider: T) => {
//         let key = schemaProvider.prototype.key;
//         implementations.set(key, schemaProvider);
//         return (ctor: Function) => console.log("FormItem class registered: " + key);
//     }
//     export const getImplementations = <T extends SchemaProvider<IFormItem>>() : Map<string, SchemaProviderWrapper> => {
//         return implementations;
//     }
//     export const getSchemaProvider = <T extends SchemaProvider<IFormItem>>(key: string) : SchemaProviderWrapper | undefined => {
//         return implementations.get(key);
//     }
// }
//-----------------------------------------------------------------------------------------------
// // add a registry of the type you expect
// export namespace IFormItem {
//     const implementations: Map<FormItemWrapper, SchemaProviderWrapper> = new Map();
//     export const register = <V extends FormItemWrapper, T extends SchemaProviderWrapper>(name: V, schemaProvider: T) => {
//         implementations.set(name, schemaProvider);
//         return (ctor: Function) => console.log("FormItem class registered: " + name);
//     }
//     export const getImplementations = <T extends SchemaProvider<IFormItem>>() : Map<FormItemWrapper, SchemaProviderWrapper> => {
//         return implementations;
//     }
//     export const getSchemaProvider = <T extends SchemaProvider<IFormItem>>(key: FormItemWrapper) : SchemaProviderWrapper | undefined => {
//         return implementations.get(key);
//     }
// }
//# sourceMappingURL=IFormItem.js.map