import { IDynamicComponentConfig } from "../builders/custom/config/IDynamicComponentConfig";
import { IFormItemComponentConfig } from "../builders/custom/config/IFormItemComponentConfig";
import { IDynamicArrayFieldConfig } from "../builders/custom/config/IDynamicArrayFieldConfig";
import { IFormItemPropertyOptions } from "../models/options/IFormItemPropertyOptions";
import { IFormItem } from "../modules/IFormItem";
import { IDynamicBooleanConfig } from "../builders/fluentUI/components/dynamicComponents/config/IDynamicBooleanConfig";
import { IDynamicDateFieldConfig } from "../builders/fluentUI/components/dynamicComponents/config/IDynamicDateFieldConfig";
import { IDynamicJsonFieldConfig } from "../builders/fluentUI/components/dynamicComponents/config/IDynamicJsonfieldConfig";
import { IDynamicPredefinedArrayFieldConfig } from "../builders/fluentUI/components/dynamicComponents/config/IDynamicPredefinedArrayFieldConfig";
import { IDynamicTextFieldConfig } from "../builders/fluentUI/components/dynamicComponents/config/IDynamicTextfieldConfig";
import { AtLeast } from "../interfaces/types/Partials";
export declare const propertyOptionsFactory: {
    stringPropertyOption: <T extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T, IDynamicTextFieldConfig>, "displayName">) => Partial<IFormItemPropertyOptions<T, IDynamicTextFieldConfig>>;
    numberPropertyOption: <T_1 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_1, IDynamicTextFieldConfig>, "displayName">) => Partial<IFormItemPropertyOptions<T_1, IDynamicTextFieldConfig>>;
    datePropertyOption: <T_2 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_2, IDynamicDateFieldConfig>, "displayName">) => Partial<IFormItemPropertyOptions<T_2, IDynamicDateFieldConfig>>;
    booleanPropertyOption: <T_3 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_3, IDynamicBooleanConfig>, "displayName">) => Partial<IFormItemPropertyOptions<T_3, IDynamicBooleanConfig>>;
    customComponentPropertyOption: <T_4 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_4, AtLeast<IDynamicComponentConfig, "component">>, "displayName">) => Partial<IFormItemPropertyOptions<T_4, IDynamicComponentConfig>>;
    formItemPropertyOption: <T_5 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_5, AtLeast<IFormItemComponentConfig, "itemType">>, "displayName">) => Partial<IFormItemPropertyOptions<T_5, IFormItemComponentConfig>>;
    jsonPropertyOption: <T_6 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_6, IDynamicJsonFieldConfig>, "displayName">) => Partial<IFormItemPropertyOptions<T_6, IDynamicJsonFieldConfig>>;
    predefinedArrayPropertyOption: <T_7 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_7, AtLeast<IDynamicPredefinedArrayFieldConfig, "predefinedOptions">>, "displayName">) => Partial<IFormItemPropertyOptions<T_7, IDynamicPredefinedArrayFieldConfig>>;
    arrayPropertyOption: <T_8 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_8, IDynamicArrayFieldConfig>, "displayName">) => Partial<IFormItemPropertyOptions<T_8, IDynamicArrayFieldConfig>>;
};
