"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormSchemaUtil = void 0;
const Language_1 = require("../../models/language/Language");
const IFormItem_1 = require("../../modules/IFormItem");
class FormSchemaUtil {
}
exports.FormSchemaUtil = FormSchemaUtil;
_a = FormSchemaUtil;
FormSchemaUtil.GetSchemaFromItem = (type, dynamicKey) => __awaiter(void 0, void 0, void 0, function* () {
    let schemaType = IFormItem_1.IFormItem.getSchemaProvider(type);
    if (schemaType == null) {
        console.error(`${Language_1.lang.texts.areas.common.schemaNotFound} Make sure to register your schema provider using the '@IFormItem.register' method.`);
        return undefined;
    }
    let schema = new schemaType.provider();
    return yield schema.getSchema(dynamicKey);
});
//# sourceMappingURL=FormSchemaUtil.js.map