"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mergeDeep = void 0;
const mergeDeep = (...objects) => {
    const isObject = (obj) => obj && typeof obj === 'object';
    const filteredObjects = objects.filter(_ => _ != null);
    return filteredObjects.reduce((prev, obj) => {
        if (obj == null)
            return prev;
        Object.keys(obj).forEach(key => {
            const pVal = prev[key];
            const oVal = obj[key];
            if (Array.isArray(pVal) && Array.isArray(oVal)) {
                prev[key] = pVal.concat(...oVal);
            }
            else if (isObject(pVal) && isObject(oVal)) {
                prev[key] = (0, exports.mergeDeep)(pVal, oVal);
            }
            else {
                prev[key] = oVal;
            }
        });
        return prev;
    }, {});
};
exports.mergeDeep = mergeDeep;
// using 'prev' cast to any because fuckshitass!! (ewi)
// https://github.com/microsoft/TypeScript/issues/31661
//# sourceMappingURL=MergeObjects.js.map