"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fetchSchema = void 0;
const FormSchemaUtil_1 = require("./FormSchemaUtil");
const MergeObjects_1 = require("./MergeObjects");
const fetchSchema = (itemType, formItemConfigOverrides, propertyOverrides, dynamicKey) => __awaiter(void 0, void 0, void 0, function* () {
    let schema = yield FormSchemaUtil_1.FormSchemaUtil.GetSchemaFromItem(itemType, dynamicKey);
    if (schema == null)
        return undefined;
    // merge with overrides
    let merged = (0, MergeObjects_1.mergeDeep)(schema === null || schema === void 0 ? void 0 : schema.options, formItemConfigOverrides);
    // property overrides
    let disabledOverrides = propertyOverrides === null || propertyOverrides === void 0 ? void 0 : propertyOverrides.disabledProps;
    let hiddenOverrides = propertyOverrides === null || propertyOverrides === void 0 ? void 0 : propertyOverrides.hiddenProps;
    Object.keys(merged.properties).forEach(_ => {
        if (disabledOverrides != null) {
            let disable = false;
            if (Array.isArray(disabledOverrides) && disabledOverrides.indexOf(_) >= 0)
                disable = true;
            else
                disable = !!disabledOverrides;
            if (disable)
                merged.properties[_].disable = () => true;
        }
        if (hiddenOverrides != null && hiddenOverrides.indexOf(_) >= 0) {
            merged.properties[_].hide = () => true;
        }
    });
    schema.options = merged;
    return schema;
});
exports.fetchSchema = fetchSchema;
//# sourceMappingURL=SchemaFetch.js.map